#ifndef ThreeBodyProblemVectorField_h
#define ThreeBodyProblemVectorField_h

#include "capd/capdlib.h"

#include "LocalVField.h"
#include "utils.h"

using namespace std;
using namespace capd;
using namespace capd::matrixAlgorithms;
using capd::autodiff::Node;

//////////////////////////////////
// class: TBP
//
// Purpose: The aim of the class is to consider a three body problem vector field with parameter mu

class ThreeBodyProblemVectorField
{
public:
    
    interval mu;
    
	IMap F;
    
	IVector L1;
    
    interval lambda;
    interval v;
    
	IMatrix C;
    
    IMap psi;
    LocalVField Floc;
	
	ThreeBodyProblemVectorField(interval mu_);
    
    void print_param();
    
    void change_mu(interval mu_);
    
private:
    
    void init_F();
    void init_L1();
    void init_C();
    void init_psi();
    void init_Floc();
};

#endif
